unit Unit1;
 //nejhorsi klient vsech dob
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, StdCtrls, xmldom, XMLIntf, ComCtrls, msxmldom, XMLDoc;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Memo1: TMemo;
    http: TIdHTTP;
    XMLDocument1: TXMLDocument;
    TreeView1: TTreeView;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Edit8: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure httpConnected(Sender: TObject);
    procedure tree(xmln:Ixmlnode;tree:Ttreenode);
    function findendtime(xmln:Ixmlnode):string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  chyba:bool;
  cas:TDateTime;
implementation

{$R *.dfm}


//vraci hodnotu dojeti vlaku
function Tform1.findendtime(xmln:Ixmlnode):string;
var i:integer;
    s:string;
begin
  //ukazuje na posledni vlak spoje
  for i:= 0 to xmln.ChildNodes.Count - 1 do
     begin
       if (xmln.ChildNodes.Nodes[i].NodeName='Poznamka')  //je  to poznamka tak potom zkoncim
         then
           break;
        if ((xmln.ChildNodes.Nodes[i].NodeName='Stanice'))   then       //kdyz ne veymu cas a prepisu ten minulej a tim ziskam ten posledni
        begin
          try
            s:=xmln.ChildNodes.Nodes[i].Attributes['odjezd'];
          except
            break;
          end;  
        end;
     end;
  findendtime:=s;
end;



//parser xml
procedure tform1.tree(xmln:Ixmlnode;tree:Ttreenode);
var i:integer;
    newt: Ttreenode;
    s:string;
    art: Ixmlnode;
begin
  if (xmln.NodeType<>ntelement) then  //jen dobre uzli
    exit;

  s:=xmln.NodeName;
  if (s='Spoj') then  //kdyz de o spoj dopl cas
  begin
    s:=s+' '+xmln.ChildNodes.Nodes[0].ChildNodes.nodes[0].Attributes['odjezd'];
    s:=s+' '+findendtime(xmln.ChildNodes.Nodes[xmln.ChildNodes.Count - 1]);

  end;

  if xmln.IsTextElement then//vypsani odnoty
    s:=s+'='+xmln.NodeValue;

  newt:=treeview1.Items.AddChild(tree,s);

  for i:= 0 to xmln.AttributeNodes.Count-1 do      //atributy
    begin
      art:=xmln.AttributeNodes.Nodes[i];
      treeview1.Items.AddChild(newt,art.NodeName+' '+art.Nodevalue);
    end;

  if xmln.HasChildNodes then
        for i:= 0 to xmln.ChildNodes.Count - 1 do
                form1.tree(xmln.ChildNodes.Nodes[i] ,newt) ;//spracuj dolsi uzli
end;


procedure TForm1.Button1Click(Sender: TObject);
var s:string;
begin
  http.Host:=edit1.Text;
  http.Port:=strtoint(edit2.Text);
  label9.Caption:='nalezen';
  treeview1.Items.Clear;
  chyba:=false;
  http.Connect;
  if (chyba) then
  begin
    label9.Caption:='nenalezen'  ;
    exit;
  end;
  form1.XMLDocument1.LoadFromFile('data.xml');
  treeview1.Items.Clear;
  tree(form1.XMLDocument1.DocumentElement,nil);  //parser

  

end;


//komunikace
procedure TForm1.httpConnected(Sender: TObject);
var s:string;

begin
  // zasilani dat na server
  http.WriteLn('GET /NajdiSpojeni?odkud='+edit3.Text+'&kam='+edit4.Text+'&pres='+edit8.Text+'&odjezd='+edit7.Text+'&spojeni='+edit6.Text+ '&prestupy='+ edit5.Text+' HTTP/1.0');
  http.WriteLn('Host: '+edit1.text);
  http.WriteLn('blabla');
  http.writeln('');

  //odstraneni protokolu
  s:=http.readln(#13+#10);
  s:=http.readln(#13+#10);
  s:=http.readln(#13+#10);
  memo1.Lines.Clear;

  while true do       //cteni dat
  begin

       // http.ReadLnWait;
        try
          s:=http.readln(#13+#10);
        except
          chyba:=true;
          break;
        end;

        memo1.Lines.Add(s);
        if (pos(s,'</Chyba>')>0) then
          begin
            chyba:=true;
            break;
          end;
        if (pos(s,'</Spojeni>')>0)  then
          break;


  end;

  memo1.Lines.SaveToFile('data.xml'); //ulozeni nactenych dat pres memo ---fuj
  http.Disconnect;
  {s:=http.readln(s);
  memo1.Lines.Add(s);
   }


end;

end.
